import { defineComponent as Y, ref as a, onMounted as _, nextTick as w, onBeforeUnmount as q, watch as M } from "vue";
import O from "resize-observer-polyfill";
import { requestAnimationFrame as C, cancelAnimationFrame as W } from "raf-polyfill-es";
import "mutationobserver-shim";
const K = Y({
  name: "AutoScroll",
  props: {
    speed: {
      type: Number,
      default: 3
    },
    resumeTime: {
      type: Number,
      default: 1e3
    },
    /**
     * [间隔大小， 停顿毫秒]
     */
    interval: {
      type: Array
      // default: () => [95, 2000],
    },
    onScroll: {
      type: Function
    },
    onResetBefore: {
      type: Function
    },
    onScrollStart: {
      type: Function
    },
    onScrollEnd: {
      type: Function
    }
  },
  setup(l) {
    const c = a(null), r = a(null), t = a(0), u = a(!1), R = a(!1), d = a(!1), h = a(!1), A = a(!1), y = a(0), s = a(0);
    let i = null, v = null, f = null, m = null;
    const T = () => {
      if (!c.value || !r.value) return;
      y.value = c.value.clientHeight, s.value = r.value.clientHeight;
      const e = s.value > y.value;
      u.value = e, R.value = e, B(t.value, e, !0, (n) => {
        t.value = n, e ? S() : o();
      });
    };
    function B(e, n, b, F) {
      typeof l.onResetBefore == "function" ? l.onResetBefore(e, n, b, F) : F(n ? e : 0);
    }
    let g = 0;
    function E(e) {
      -t.value >= s.value ? B(t.value, !1, !1, (n) => {
        t.value = n, e == null || e();
      }) : e == null || e();
    }
    const H = () => {
      if (!u.value || d.value || !h.value) {
        i = null;
        return;
      }
      const e = 0.5 * (l.speed / 3);
      if (t.value -= e, g -= e, Array.isArray(l.interval) && Math.abs(g) >= l.interval[0]) {
        o(), setTimeout(() => {
          E(() => {
            S(), g = 0;
          });
        }, l.interval[1]);
        return;
      }
      E(() => {
        i = C(H);
      });
    }, S = () => {
      h.value || !u.value || (h.value = !0, i = C(H));
    }, o = () => {
      h.value = !1, i && (W(i), i = null);
    }, N = (e) => {
      var n;
      u.value && (e.preventDefault(), d.value = !0, o(), !(e.deltaY < 0 && Math.abs(t.value) <= 0) && (t.value -= e.deltaY * 0.6, P(), Math.abs(t.value) <= 0 && ((n = l == null ? void 0 : l.onScrollStart) == null || n.call(l, t.value))));
    }, P = () => {
      const e = s.value - y.value;
      t.value = Math.max(-e, Math.min(0, t.value));
    }, k = (e) => {
      v && clearTimeout(v), v = setTimeout(() => {
        d.value = !1, u.value && S();
      }, e);
    }, D = () => {
      u.value && (d.value = !0, o());
    }, I = () => {
      k(l.resumeTime);
    }, L = () => {
      c.value && (f = new O(T), f.observe(c.value)), r.value && (m = new MutationObserver(() => {
        w(T);
      }), m.observe(r.value, {
        childList: !0,
        subtree: !0,
        characterData: !0
      }));
    };
    _(() => {
      w(() => {
        T(), L();
      });
    }), q(() => {
      o(), f == null || f.disconnect(), m == null || m.disconnect(), v && clearTimeout(v);
    }), M(() => l.speed, () => {
      u.value && (o(), S());
    }), typeof l.onScroll == "function" && M(() => t.value, l.onScroll), typeof l.onScrollEnd == "function" && M(() => t.value, () => {
      var b;
      const e = s.value - y.value, n = Math.abs(t.value) >= e;
      !A.value && n ? (A.value = !0, (b = l == null ? void 0 : l.onScrollEnd) == null || b.call(l, t.value)) : n || (A.value = !1);
    });
    function U(e) {
      t.value = e;
    }
    return {
      container: c,
      originalContent: r,
      scrollPosition: t,
      shouldClone: R,
      setScrollTop: U,
      handleWheel: N,
      pauseScroll: D,
      resumeScroll: I,
      startAutoScroll: S,
      stopAutoScroll: o,
      resetResumeTimer: k
    };
  }
});
export {
  K as default
};
